#include "MIDIUSB.h"

struct button{
  uint8_t port;
  bool pressed;
  uint8_t count;
};

struct pot{
  uint8_t port;
  uint8_t last;
};

button buttons [8];
pot pots[4];

void setup()
{

  for(int i=0; i<8; i++){
    buttons[i].port = 12-i;
    buttons[i].pressed = false;
    buttons[i].count = 0;
    pinMode(buttons[i].port, INPUT_PULLUP);
  }

  for(int i=0; i<4; i++){
    pots[i].port = i+A1;
    pots[i].last = 0;
  }
}

void loop()
{
  // buttons
  for(int i=0; i<8; i++){
    if(!digitalRead(buttons[i].port)){
      if(!buttons[i].pressed && millis() - buttons[i].count > 2){
        uint8_t note = buttons[i].port+31;
        midiEventPacket_t noteOn = {0x09, 0x90 | 1, note, 127};
        MidiUSB.sendMIDI(noteOn);
        buttons[i].pressed = true;
      }
    } else {
      if(buttons[i].pressed == true){
        uint8_t note = buttons[i].port+31;
        midiEventPacket_t noteOff = {0x08, 0x80 | 1, note, 0};
        MidiUSB.sendMIDI(noteOff);
      }
      buttons[i].pressed = false;
      buttons[i].count = millis();
    }
  }

  //pots
  for(uint8_t i=0; i<4; i++){
    uint8_t val = analogRead(pots[i].port)*(127.0/685.0);
    if(val > 127)
      val = 127;
    if(abs(val - pots[i].last) > 1){
      pots[i].last = val;
      midiEventPacket_t event = {0x0B, 0xB0 | 1, pots[i].port, val};
      MidiUSB.sendMIDI(event);
    }
  }
  MidiUSB.flush();
}
